#!/usr/bin/env python

"""
This test attempts to demonstrate that the usage associated with the global
'obj' cannot be reliably calculated since a function exists that rebinds the
name.
"""

class C:
    def f(self): # unused but retained
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def f(self): # unused but retained
        return 4

    def h(self): # unused
        return 5

def change_global():
    global obj
    obj = E() # changes the global, potentially invalidating usage observations

c = C()
d = D()
e = E()

obj = c
obj = d

if obj.f():
    obj.g()
    change_global()
    x = obj.f()
else:
    x = 2

result_4 = x

# vim: tabstop=4 expandtab shiftwidth=4
